//Carlos Gershenson

#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <dos.h>
#include <conio.h>

unsigned long t=0;//time;
		  //in reality, it isnt discrete
const scale=20;//(1 pixel=scale meters)
	       //note that cars are drawed in no relation to scale
	       //cars would have a scale of 1 (1 meter=1 pixel)
class CCar{
  float mx,my,//coords (1 pixel=scale meters)
	   mv,//velocity in meters/second
	   ma;//acceleration in meters/second^2

	      //***destination coords

  int mdir,   //direction (clockwise){0,3,6,9}
      mcolor, //car color
      mid;    //car id number. ***If they are repeated... REAL trouble

  public:
  CCar()
   {mx=0;my=0;mv=50;ma=0;mdir=0;mcolor=15;mid=0;}
  CCar(float x, float y,float v, float a,int dir,int color,int id)
    {mx=x;my=y;mv=v;ma=a;mdir=dir;mcolor=color;mid=id;}
  float GetX(){return mx;}
  float GetY(){return my;}
  float GetV(){return mv;}
  float GetA(){return ma;}
  int GetID(){return mid;}
  int GetDir(){return mdir;}
  int GetColor(){return mcolor;}
  void Set(float x, float y,float v, float a,int dir,int color,int id)
    {mx=x;my=y;mv=v;ma=a;mdir=dir;mcolor=color;mid=id;}
  void SetV(float v){mv=v;}
  void SetA(float a)
  {ma=a;
  delay(0);}
  void State();//sets states of Car
  void Trans();//sets transitions of Car
  void Draw(int color);//draws car. If color=0, black; otherwise, mcolor

};

void CCar::State(){//sets states of Car and its transitions
  if ((mv>=16)&&(mv<=19)) ma=0;//cruise speed(57.6-68.4 Km/Hr)
  if (mv<16) ma=0.5;  //in reality acceleration doesent turns from 0 to 0.5
  if (mv>19) ma=-0.5; //instantly...
}
void CCar::Trans(){//sets transitions
  mv=mv+ma;//apply acceleration to velocity (even if a=0)
  switch (mdir){
    case 0:my=my-mv;break;
    case 3:mx=mx+mv;break;
    case 6:my=my+mv;break;
    case 9:mx=mx-mv;break;
  }
  //***car needs to check if car in front exists

  //this next 4 ifs make the cross cyclic
  if (mx>640*scale) mx=0;
  if (my>480*scale) my=0;
  if (mx<0) mx=640*scale;
  if (my<0) my=480*scale;
}

void CCar::Draw(int color){
  int x=mx/scale,y=my/scale;
  if (color!=0)
  setcolor(mcolor);
  else
  setcolor(0);
  switch(mdir){
    case 0:{rectangle(x+1,y-1,x+3,y+2);
	     setcolor(0);
	     line(x+1,y,x+3,y);break;}
    case 3:{rectangle(x-2,y+1,x+1,y+3);
	     setcolor(0);
	     line(x,y+1,x,y+3);break;}
    case 6:{rectangle(x-3,y-2,x-1,y+1);
	     setcolor(0);
	     line(x-3,y,x-1,y);break;}
    case 9:{rectangle(x-1,y-1,x+2,y-3);
	     setcolor(0);
	     line(x,y-1,x,y-3);break;}
  }
}

typedef struct{
  int id;          //car id
  unsigned long t; //previewed time
}pstack;//struct of pseudo-stack (maximum cars capable of controling)

const maxps=15;//size of pseudo-stack

class CCross{  //road cross
  float mx,my;//coords
  int mdirs[4];//allowed directions
  public:
  pstack mps[maxps];//pseudo-stack
  CCross(float x,float y,
	 int d0,int d3,int d6,int d9);
  void State(CCar &c);//sets states of Cross and its transitions
};

CCross::CCross(float x,float y,int d0,int d3,int d6,int d9){
    mx=x;my=y;
    mdirs[0]=d0;mdirs[1]=d3;
    mdirs[2]=d6;mdirs[3]=d9;
    for(int i=0;i<maxps;i++){
      mps[i].id=-1;
      mps[i].t=-1;
    }
}

void CCross::State(CCar &c){//sets states of Cross and its transitions
			   //call it after CCar::State()
			   //(the Cross must overrule the car)
			   //but before CCar::Trans()
  float x=c.GetX()-mx;
  float y=c.GetY()-my;
  float v=c.GetV();
  float a=c.GetA();
  int dir=c.GetDir();
  int id=c.GetID();
  float d=sqrt((x*x)+(y*y));//calculates distance to car

  int approach=0;
  switch(dir){       //checks if car is approaching
	case 0:if(y>0) approach=1; break;
	case 3:if(x<0) approach=1; break;
	case 6:if(y<0) approach=1; break;
	case 9:if(x>0) approach=1; break;
  }
  if (approach){
    int freepspos=-1,pspos=-1;
    for (int i=0;i<maxps;i++){
      if ((mps[i].id==-1)&&(freepspos==-1))
	freepspos=i;//gets first free position
      if (mps[i].id==id)
	pspos=i;//if car has been assigned, gets position
    }
    if (pspos==-1){ //if car is new, assigns a position in mps
      mps[freepspos].id=id;
      pspos=freepspos;
    }
    int ok=0; //flag
    float ind=0;//index to adjust speed
    while (!ok){
      d=sqrt((x*x)+(y*y));
      v=c.GetV();
      a=-0.5;

      mps[pspos].t=t;//start timer
      int ind2=0;
      while (d>0){
	if (ind2<ind)
	v=v+a;//apply acceleration to velocity (even if a=0)
	d=d-v;
	mps[pspos].t++;
	ind2++;
      }
      ind++;
      ok=1;

      for (int i=0;i<maxps;i++)//checks if theres enough space to the car to pass
	if (i!=pspos)
	  if (abs(mps[i].t-mps[pspos].t)<2)
	    ok=0;//leaves more than 32 meters of margin
    }
	if (ind==1)
      c.SetA(0);
    else
      c.SetA(a);

  }
  else
    for (int i=0;i<maxps;i++)  //if car has been assigned, free position
      if (mps[i].id==id) mps[i].id=-1;
}



  CCross c1(6400,4800,1,1,1,1);



void car(){
//Inicialization
  line(0,235,315,235);
  line(0,245,315,245);
  line(640,235,325,235);
  line(640,245,325,245);
  line(315,0,315,235);
  line(325,0,325,235);
  line(315,480,315,245);
  line(325,480,325,245);

  CCar a[12];
  a[1].Set(5200,4800,15,0,3,9,1001);
  a[2].Set(6400,6000,15,0,0,4,1002);
  a[3].Set(7600,4800,15,0,9,3,1003);
  a[4].Set(6400,3600,15,0,6,12,1004);
  a[5].Set(4170,4800,15,0,3,8,1005);
  a[6].Set(6400,7030,15,0,0,5,1006);
  a[7].Set(8630,4800,15,0,9,2,1007);
  a[8].Set(6400,2570,15,0,6,11,1008);
  a[9].Set(3140,4800,15,0,3,15,1009);
  a[10].Set(6400,8060,15,0,0,8,1010);
  a[11].Set(9660,4800,15,0,9,7,1011);
  a[0].Set(6400,1540,15,0,6,1,1000);

//end of Inicialization
double d;

  while (!kbhit()){
    for (int i=0;i<12;i++)
      a[i].Draw(1);
    delay(10);
    for (i=0;i<12;i++){
      a[i].Draw(0);
      a[i].State();
      c1.State(a[i]);
      a[i].Trans();

    }
    int i2;
    for (i2=0;i2<12;i2++)
      for (int i3=0;i3<12;i3++)
	if (i2!=i3){
	  d=sqrt(pow(a[i2].GetX()-a[i3].GetX(),2)+pow(a[i2].GetY()-a[i3].GetY(),2));
	  if (d<10)
	    {setcolor(4);circle(a[i3].GetX()/scale,a[i3].GetY()/scale,10);}

    }
    t++;
  }
};

int main(void)
{
   int gdriver = DETECT, gmode, errorcode;
   initgraph(&gdriver, &gmode, "");
   errorcode = graphresult();
   if (errorcode != grOk)
   {
	  printf("Graph Error: %s\n", grapherrormsg(errorcode));
	  exit(1);
   }
   car();
   closegraph();
   return 0;
}
