#include<iostream.h>
#include<stdio.h>
// Enumeracion de los booleanos
enum BOOL{TRUE=1,FALSE=0};
///////////////////////////////////
// Clase de los nodos con templates
///////////////////////////////////
template<class T>
class nodo {
     T valor;
     nodo *sig;
  public:
     nodo(T v){ valor=v;
		sig=NULL;
	      }
     nodo(T v,nodo *s){
	   valor=v;
	   sig=s;
     }
     void ligar(nodo *s){
	 sig=s;
     }
     void siguiente(nodo *s){
	 ligar(s);
     }
     nodo *siguiente(void){
	 return sig;
     }
     T val(void){
	return valor;
     }
     BOOL val(T v){
	 return (valor==v)?TRUE:FALSE;
     }
     BOOL operator < (T v){
	 return (valor<v)?TRUE:FALSE;
     }
     BOOL operator > (T v){
	 return (valor>v)?TRUE:FALSE;
     }
};
///////////////////////////////////////
// Sobrecarga del operador << para cout
///////////////////////////////////////
template<class T>void operator<<(ostream_withassign &cOut,nodo<T> *n){
   cOut<<n->val();
}
///////////////////////////////////
// Clase de las listas con templates
///////////////////////////////////////
template<class T>
class lista {
   protected:
     nodo<T> *cabeza;
   public:
     lista(void){   cabeza=NULL; }
     ~lista(void);
     void operator+(T valor);
     void operator-(T valor);
     void print(void);
};
///////////////////////////////////////////
// Implementacion de la clase de las listas
///////////////////////////////////////////
template<class T> void lista<T>::operator+(T valor){
     if(cabeza==NULL)
	 cabeza=new nodo<T>(valor);
     else{
	 nodo<T> *nuevo=new nodo<T>(valor);
	 for(nodo<T> *rec=cabeza; rec->siguiente() ; rec=rec->siguiente())
				   ;
	 rec->ligar(nuevo);
     }
};
template<class T> void lista<T>::operator-(T valor){
     if(cabeza){
	  if(cabeza->val(valor)){
	     nodo<T> *temp=cabeza;
	     cabeza=cabeza->siguiente();
	     delete temp;
	  }
	  else{
	     nodo<T> *rec=cabeza;
	     while(rec->siguiente() && !rec->siguiente()->val(valor))
		   rec=rec->siguiente();
	     if(rec->siguiente()->val(valor)){
		nodo<T> *temp=rec->siguiente();
		rec->siguiente(rec->siguiente()->siguiente());
		delete temp;
	     }
	  }
     }
}
template<class T> void lista<T>::print(void){
      nodo<T> *rec=cabeza;
      while(rec){
	  cout<<rec;
	  cout<<"\n";
	  rec=rec->siguiente();
      }
}
template<class T>lista<T>::~lista(void){
      nodo<T> *rec=cabeza;
      while(rec){
	  cabeza=rec;
	  rec=rec->siguiente();
	  delete cabeza;
      }
      cabeza=NULL;
}
////////////////////////////////////////////////////////////
// Un ejemplo de como sobrecarcar el operador << de cout
////////////////////////////////////////////////////////////
template<class T>void operator<<(ostream_withassign &,lista<T> &l){
       l.print();
}
///////////////////////////////////////
// Un ejemplo con herencia y templates
///////////////////////////////////////
template<class T>
class OrderedCollection:public lista<T>{
   public:
     OrderedCollection(void):lista<T>(){}
     OrderedCollection & operator+(T valor);
};
////////////////////////////////////////////////////////////
// Un ejemplo de como sobrecarcar el operador << de cout
////////////////////////////////////////////////////////////
template<class T>void operator<<(ostream_withassign &,OrderedCollection<T> &l){
       l.print();
}
template<class T> OrderedCollection<T> &OrderedCollection<T>::operator+(T valor){
     nodo<T> *nuevo;

     if(cabeza==NULL)
	 cabeza=new nodo<T>(valor);
     else{
	 if(*cabeza > valor){   // Se hace la insercion antes de la cabeza
	     nuevo=new nodo<T>(valor,cabeza);
	     cabeza=nuevo;
	 }
	 else{
	    for(nodo<T> *rec=cabeza; rec->siguiente() && *(rec->siguiente()) < valor ; rec=rec->siguiente())
				   ;
	    if(rec->siguiente() && !rec->siguiente()->val(valor)){
		nuevo=new nodo<T>(valor,rec->siguiente());
		rec->siguiente(nuevo);
	    }
	    else{
		rec->siguiente(new nodo<T>(valor));
	    }
	}
     }
     return *this;
};
///////////////////////////////////////
// Programa principal
//////////////////////////////////////
void main(void){
   OrderedCollection<int> l;

   l+1;
   l+2;
   l+3+3+8+9+0; // Esto no se puede hacer en el caso de la lista
   l+4;
   //l.print();
   cout<<l;
}